package edu.brynmawr.RocketA;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.util.Log;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;
import java.util.Date;

abstract class DownloadRunner implements Runnable
{

	@SuppressWarnings("unused")
	String webInvokeImageUpload(String urlString, String[][] args, byte[] data)
	{
		Log.i("THISS", "Runner upload image bytes " + data.length);
		HttpURLConnection connection;
		DataOutputStream outputStream;

		String twoHyphens = "--";
		String boundary = "*****" + System.currentTimeMillis() + "*****";
		String lineEnd = "\r\n";

		StringBuilder response = new StringBuilder();

		try
		{
			URL url = new URL(urlString);
			connection = (HttpURLConnection) url.openConnection();

			connection.setDoInput(true);
			//connection.setDoOutput(true);
			connection.setUseCaches(false);

			connection.setRequestMethod("POST");
			connection.setRequestProperty("Connection", "Keep-Alive");
			connection.setRequestProperty("User-Agent", "Android Multipart HTTP Client 1.0");
			connection.setRequestProperty("Content-Type", "multipart/form-data; boundary=" + boundary);

			outputStream = new DataOutputStream(connection.getOutputStream());
			outputStream.writeBytes(twoHyphens + boundary + lineEnd);
			outputStream.writeBytes("Content-Disposition: form-data; name=\"" + "Image" + "\"; filename=\"" + "image.jpg" + "\"" + lineEnd);
			outputStream.writeBytes("Content-Type: " + "image/jpg" + lineEnd);
			outputStream.writeBytes("Content-Transfer-Encoding: binary" + lineEnd);

			outputStream.writeBytes(lineEnd);

			outputStream.write(data, 0, data.length);

			outputStream.writeBytes(lineEnd);


			for (String[] ap : args)
			{
				String key = ap[0];
				String value = ap[1];

				outputStream.writeBytes(twoHyphens + boundary + lineEnd);
				outputStream.writeBytes("Content-Disposition: form-data; name=\"" + key + "\"" + lineEnd);
				outputStream.writeBytes("Content-Type: text/plain" + lineEnd);
				outputStream.writeBytes(lineEnd);
				outputStream.writeBytes(value);
				outputStream.writeBytes(lineEnd);
			}

			outputStream.writeBytes(twoHyphens + boundary + twoHyphens + lineEnd);
			outputStream.flush();

			InputStream inputStream = connection.getInputStream();
			BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream, StandardCharsets.UTF_8));
			String line;
			while ((line = bufferedReader.readLine()) != null)
			{
				response.append(line);
			}
			bufferedReader.close();
			inputStream.close();
			connection.disconnect();
			outputStream.close();


			return response.toString();
		}
		catch (Exception e)
		{
			Log.i("KIKL", e.toString());
			e.printStackTrace();
		}
		return "";
	}

	@SuppressWarnings("unused")
	byte[] getBitmapAsByteArray(Bitmap bitmap) {
		ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
		bitmap.compress(Bitmap.CompressFormat.JPEG, 100, outputStream);
		return outputStream.toByteArray();
	}

	@SuppressWarnings("unused")
	private int calculateInSampleSize(BitmapFactory.Options options, int reqWidth, int reqHeight)
	{
		// Raw height and width of image
		final int height = options.outHeight;
		final int width = options.outWidth;
		int inSampleSize = 1;

		if (height > reqHeight || width > reqWidth) {

			final int halfHeight = height / 2;
			final int halfWidth = width / 2;

			// Calculate the largest inSampleSize value that is a power of 2 and keeps both
			// height and width larger than the requested height and width.
			while ((halfHeight / inSampleSize) >= reqHeight
					&& (halfWidth / inSampleSize) >= reqWidth) {
				inSampleSize *= 2;
			}
		}
		//Log.i("THISS", "INSAMPLESIZE " + inSampleSize);
		return inSampleSize;
	}


	private Bitmap decodeSampledBitmapFromResource(ByteArrayOutputStream baos, int maxWidth, int maxHeight) {

		// First decode with inJustDecodeBounds=true to check dimensions
		final BitmapFactory.Options options = new BitmapFactory.Options();
		//options.inJustDecodeBounds = true;
		BitmapFactory.decodeStream(new ByteArrayInputStream(baos.toByteArray()), null, options);
		//Log.e("THISS", "image Size " + options.outHeight + " " + options.outWidth);
		// Calculate inSampleSize
		options.inSampleSize = calculateInSampleSize(options, maxWidth, maxHeight);
		options.inJustDecodeBounds = false;
		return BitmapFactory.decodeStream(new ByteArrayInputStream(baos.toByteArray()), null, options);
	}

	@SuppressWarnings("unused")
	Bitmap webInvokeBA(String urlString, int maxWidth, int maxHeight)
	{
		HttpURLConnection conn;
		try
		{
			URL myUrl = new URL(urlString);
			conn = (HttpURLConnection) myUrl.openConnection();
			conn.setReadTimeout(10000);
			conn.setConnectTimeout(15000);
			conn.setRequestMethod("GET");
			conn.setDoInput(true);

			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			InputStream is;
			try {
				is = conn.getInputStream();
				byte[] byteChunk = new byte[4096]; // Or whatever size you want to read in at a time.
				int n;
				while ( (n = is.read(byteChunk)) > 0 ) {
					baos.write(byteChunk, 0, n);
				}
			}
			catch (Exception e) {
				System.err.printf ("Failed while reading bytes %s", e.getMessage());
				e.printStackTrace ();
				// Perform any other exception handling that's appropriate.
			}
			//Log.i("THISS", "got bitmap from " + urlString + " " + aBitmap);
			return decodeSampledBitmapFromResource(baos, maxWidth, maxHeight);
		}
		catch (Exception ee)
		{
			Log.e("UURL", ee.toString());
			ee.printStackTrace();
		}
		return null;
	}

	@SuppressWarnings("unused")
	String webInvoke(String urlString, String[][] args)
	{
		System.setProperty("http.keepAlive", "false");
		Log.d("THISS", "invoker " + urlString);
		Date sdate = new Date();
		HttpURLConnection conn;
		URL myUrl;
		StringBuilder response = new StringBuilder();
		try
		{
			myUrl = new URL(urlString);
			conn = (HttpURLConnection) myUrl.openConnection();
			conn.setReadTimeout(6000);
			conn.setConnectTimeout(5000);
			conn.setRequestMethod("POST");
			conn.setDoInput(true);
			//conn.setDoOutput(true);
			conn.setRequestProperty("Connection", "close");
			conn.connect();

			StringBuilder postData = new StringBuilder();
			boolean firstTime = true;
			for (String[] ap : args)
			{
				//Log.d("THISS", "POST PARAM: " + ap[0] + ">><<" + ap[1] + ">>");
				if (firstTime)
				{
					firstTime = false;
				} else
				{
					postData.append("&");
				}
				postData.append(URLEncoder.encode(ap[0], "UTF-8"));
				postData.append("=");
				postData.append(URLEncoder.encode(ap[1], "UTF-8"));
			}
			Log.i("THISS", "Uploading " + postData.toString());


			OutputStream os = conn.getOutputStream();
			BufferedWriter bufferedWriter = new BufferedWriter(new OutputStreamWriter(os, StandardCharsets.UTF_8));
			bufferedWriter.write(postData.toString());
			bufferedWriter.flush();
			bufferedWriter.close();
			Date eDate = new Date();
			Log.i("THISS", "WEB  POSTt " + (eDate.getTime() - sdate.getTime()));

			int status = conn.getResponseCode();
			Log.e("THISS", "Status " + status);
			if (conn.getResponseCode() < 299)
			{
				InputStream inputStream;
				inputStream = conn.getInputStream();
				BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream, StandardCharsets.UTF_8));
				String line;
				while ((line = bufferedReader.readLine()) != null)
				{
					response.append(line);
				}
				bufferedReader.close();
				inputStream.close();
				conn.disconnect();
				os.close();
				eDate = new Date();
				Log.i("THISS", "WEB  READ " + (eDate.getTime() - sdate.getTime()));
			}
			else
			{
				Log.e("THISS", "Response code indicates failure " + status);
				Thread.dumpStack();
				Log.i("THISS", "Was trying " + urlString + " with " +  postData.toString());
				return null;
			}
		}
		catch (Exception ee)
		{
			Log.e("THISS", ee.toString(), ee);
			ee.printStackTrace();
			return null;
		}
		//Log.i("UURL NEWwww", response.toString());
		return response.toString();
	}

	String webInvokeJSON(String urlString, String[][] args)
	{
		System.setProperty("http.keepAlive", "false");
		Log.d("THISS", "invoker " + urlString);
		Date sdate = new Date();
		HttpURLConnection conn;
		URL myUrl;
		StringBuilder response = new StringBuilder();
		try
		{
			myUrl = new URL(urlString);
			conn = (HttpURLConnection) myUrl.openConnection();
			conn.setReadTimeout(6000);
			conn.setConnectTimeout(5000);
			conn.setRequestMethod("POST");
			conn.setRequestProperty("Content-Type", "application/json; utf-8");
			conn.setRequestProperty("Accept", "application/json");
			//conn.setDoInput(true);
			conn.setDoOutput(true);
			conn.setRequestProperty("Connection", "close");
			conn.connect();

			StringBuilder postData = new StringBuilder();
			postData.append("{");
			boolean firstTime = true;
			for (String[] ap : args)
			{
				//Log.d("THISS", "POST PARAM: " + ap[0] + ">><<" + ap[1] + ">>");
				if (firstTime)
				{
					firstTime = false;
				} else
				{
					postData.append(", ");
				}
				postData.append("\"").append(ap[0]).append("\"");
				postData.append(":");
				postData.append("\"").append(ap[1]).append("\"");
			}
			postData.append("}");
			Log.i("THISS", "Uploading " + postData.toString());


			OutputStream os = conn.getOutputStream();
			byte[] input = postData.toString().getBytes(StandardCharsets.UTF_8);
			os.write(input, 0, input.length);
			os.close();
			Date eDate = new Date();
			Log.i("THISS", "WEB  POST " + (eDate.getTime() - sdate.getTime()));

			int status = conn.getResponseCode();
			Log.e("THISS", "Status " + status);
			if (conn.getResponseCode() < 299)
			{
				InputStream inputStream;
				inputStream = conn.getInputStream();
				BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream, StandardCharsets.UTF_8));
				String line;
				while ((line = bufferedReader.readLine()) != null)
				{
					response.append(line);
				}
				bufferedReader.close();
				inputStream.close();
				conn.disconnect();
				os.close();
				eDate = new Date();
				Log.i("THISS", "WEB  READ " + (eDate.getTime() - sdate.getTime()));
			}
			else
			{
				Log.e("THISS", "Response code indicates failure " + status);
				Thread.dumpStack();
				Log.i("THISS", "Was trying " + urlString + " with " +  postData.toString());
				return null;
			}
		}
		catch (Exception ee)
		{
			Log.e("THISS", ee.toString(), ee);
			ee.printStackTrace();
			return null;
		}
		Log.i("UURL NEWwww", response.toString());
		return response.toString();
	}




}
