package edu.brynmawr.RocketA;

import android.animation.Animator;
import android.animation.AnimatorListenerAdapter;
import android.annotation.SuppressLint;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.text.SpannableString;
import android.text.style.UnderlineSpan;
import android.util.Log;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AbsListView;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.ContextCompat;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;
import androidx.recyclerview.widget.DefaultItemAnimator;
import androidx.recyclerview.widget.DividerItemDecoration;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import org.json.JSONArray;
import org.json.JSONObject;

import java.lang.ref.WeakReference;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Random;
import java.util.concurrent.Executor;
import java.util.concurrent.RejectedExecutionException;

@SuppressWarnings("Convert2Lambda, unused")
public class FragmentLauncher extends Fragment {
    private RelativeLayout mainLayout;
    private final int set2get;

    public FragmentLauncher(int id) {
        this.set2get = id;
    }

    public View onCreateView(@NonNull LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState ) {
        // set up the initial layout
        RelativeLayout ll = new RelativeLayout(getContext());
        ll.setId(View.generateViewId());
        ll.setLayoutParams(new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
        mainLayout = ll;
        return ll;
    }

    /**
     * Generate a random color
     * @return the random color
     */
    private int randomColor() {
        Random r = new Random();
        return Color.rgb(r.nextInt(255), r.nextInt(255), r.nextInt(255));
    }

    public void onViewCreated(@NonNull View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        layoutFetching();
    }

    @SuppressLint("SetTextI18n")
    private void layoutFetching() {
        mainLayout.setBackgroundColor(randomColor());
        TextView tv = new TextView(getContext());
        tv.setText("Fetching Launcher List");
        tv.setGravity(Gravity.CENTER);
        ViewGroup.LayoutParams lp = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT);
        mainLayout.addView(tv, lp);

        tv.setRotation(0);
        tv.animate().rotation(2880).setDuration(30000).setListener(new AnimatorListenerAdapter() {
            @Override
            public void onAnimationEnd(Animator animation) {
                super.onAnimationEnd(animation);
            }
        });
        Executor exec = new Executor() {
            @Override
            public void execute(@NonNull Runnable command) {
                new Thread(command).start();
            }
        };

        try {
            exec.execute(new GetLaunchersRunner(this));
        }
        catch (RejectedExecutionException | NullPointerException exception) {
            Log.e("THISS", "Thread problem", exception);
        }
        //new Thread(new GetLaunchersRunner(this)).start();
    }

    private void stopAndFail(String failMessage) {
        mainLayout.removeAllViews();
        TextView tv = new TextView(getContext());
        tv.setText(failMessage);
        tv.setGravity(Gravity.CENTER);
        ViewGroup.LayoutParams lp = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT);
        mainLayout.addView(tv, lp);

    }

    private void gotData(final ArrayList<JSONObject> joList) {
        //gotData0(joList);
        //gotData1(joList);
        //gotData2(joList);
        gotData3(joList);
    }
    private void gotData0(final ArrayList<JSONObject> aList) {
        mainLayout.removeAllViews();
        ArrayList<String> aString = new ArrayList<>();
        for (JSONObject jo : aList)
            aString.add(jo.toString());
        ListView theLv = new ListView(getContext());
        mainLayout.addView(theLv, new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
        ArrayAdapter<String> adapter = new ArrayAdapter<>(getContext(),
                android.R.layout.simple_list_item_1, android.R.id.text1, aString);
        theLv.setAdapter(adapter);

        theLv.setOnItemClickListener(new AdapterView.OnItemClickListener() {

            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                JSONObject o = aList.get(position);
                Toast.makeText(getContext(), o.toString(),Toast.LENGTH_SHORT).show();
                FragmentManager fragmentManager = ((AppCompatActivity)getContext()).getSupportFragmentManager();
                FragmentTransaction transaction = fragmentManager.beginTransaction();
                transaction.replace(MainActivity.MAIN_ACTIVITY_ID, new FragmentLaunches(o), null);
                transaction.addToBackStack(null);
                transaction.commit();
            }
        });

    }

    private void gotData1(ArrayList<JSONObject> aList)
    {
        mainLayout.removeAllViews();
        ListView theLv = new ListView(getContext());
        mainLayout.addView(theLv, new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
        theLv.setChoiceMode(ListView.CHOICE_MODE_SINGLE);
        theLv.setBackgroundColor(Color.rgb(240, 240, 240));
        theLv.setDivider(new ColorDrawable(ContextCompat.getColor(getContext(), R.color.purple_200)));
        theLv.setDividerHeight((int)(2*getResources().getDisplayMetrics().density));
        theLv.setStackFromBottom(false);
        theLv.setTranscriptMode(ListView.TRANSCRIPT_MODE_ALWAYS_SCROLL);
        ArrayAdapter<JSONObject> aa = new ArrayAdapter<JSONObject>(getContext(), 0, aList)
        {

            @NonNull
            @SuppressLint("InflateParams")
            @Override
            public View getView(int position, View convertView, @NonNull ViewGroup parent) {
                View view = convertView;
                if (view == null) {
                    view = new LinearLayout(getContext());
                }
                JSONObject msg = this.getItem(position);
                LinearLayout ll = (LinearLayout) view;
                ll.removeAllViews();
                ll.setOrientation(LinearLayout.HORIZONTAL);
                ll.setLayoutParams(new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT));
                TextView tv = new TextView(getContext());
                tv.setText(msg.toString());
                float density = getResources().getDisplayMetrics().density;
                tv.setPadding((int) (5 * density), (int) (5 * density), (int) (3 * density), (int) (5 * density));
                tv.setGravity(Gravity.START | Gravity.CENTER_VERTICAL);
                ll.addView(tv, new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.WRAP_CONTENT, 1));
                return view;
            }

        };
        theLv.setAdapter(aa);
        theLv.setOnItemClickListener(new AdapterView.OnItemClickListener() {

            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                JSONObject o = (JSONObject)theLv.getItemAtPosition(position);
                Toast.makeText(getContext(), o.toString(),Toast.LENGTH_SHORT).show();
                FragmentManager fragmentManager = ((AppCompatActivity)getContext()).getSupportFragmentManager();
                FragmentTransaction transaction = fragmentManager.beginTransaction();
                transaction.replace(MainActivity.MAIN_ACTIVITY_ID, new FragmentLaunches(o), null);
                transaction.addToBackStack(null);
                transaction.commit();
            }
        });
    }

    @SuppressLint("SetTextI18n")
    private View headerRow(ArrayList<JSONObject> aList, ArrayAdapter<JSONObject> lv) {
        float density = getResources().getDisplayMetrics().density;
        LinearLayout ll = new LinearLayout(getContext());
        ll.setBackgroundColor(ContextCompat.getColor(getContext(), R.color.purple_200));
        ll.setOrientation(LinearLayout.HORIZONTAL);
        ll.setLayoutParams(new AbsListView.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, (int)(40*density)));
        {
            TextView tv = new TextView(getContext());
            tv.setPadding((int)(3*density),0,0,0);
            tv.setText("name");
            tv.setGravity(Gravity.START | Gravity.CENTER_VERTICAL);
            ll.addView(tv, new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.MATCH_PARENT, 3));
            tv.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    reSort(aList, "name");
                    lv.notifyDataSetChanged();
                }
            });
        }
        {
            View v = new View(getContext());
            v.setBackgroundColor(ContextCompat.getColor(getContext(), R.color.purple_500));
            ll.addView(v, new LinearLayout.LayoutParams((int)(0.5*density), ViewGroup.LayoutParams.MATCH_PARENT, 0));
        }
        {
            TextView tv = new TextView(getContext());
            tv.setText("count");
            tv.setGravity(Gravity.CENTER_HORIZONTAL | Gravity.CENTER_VERTICAL);
            ll.addView(tv, new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.MATCH_PARENT, 1));
            tv.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    reSort(aList, "count");
                    lv.notifyDataSetChanged();
                }
            });
        }
        {
            View v = new View(getContext());
            v.setBackgroundColor(ContextCompat.getColor(getContext(), R.color.purple_500));
            ll.addView(v, new LinearLayout.LayoutParams((int)(0.5*density), ViewGroup.LayoutParams.MATCH_PARENT, 0));
        }
        {
            TextView tv = new TextView(getContext());
            tv.setPadding((int)(3*density),0,0,0);
            tv.setText("first");
            tv.setGravity(Gravity.START | Gravity.CENTER_VERTICAL);
            ll.addView(tv, new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.MATCH_PARENT, 3));
            tv.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    reSort(aList, "first");
                    lv.notifyDataSetChanged();
                }
            });
        }
        {
            View v = new View(getContext());
            v.setBackgroundColor(ContextCompat.getColor(getContext(), R.color.purple_500));
            ll.addView(v, new LinearLayout.LayoutParams((int)(0.5*density), ViewGroup.LayoutParams.MATCH_PARENT, 0));
        }
        {
            TextView tv = new TextView(getContext());
            tv.setPadding((int)(3*density),0,0,0);
            tv.setText("recent");
            tv.setGravity(Gravity.START | Gravity.CENTER_VERTICAL);
            ll.addView(tv, new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.MATCH_PARENT, 3));
            tv.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    reSort(aList, "recent");
                    lv.notifyDataSetChanged();
                }
            });
        }
        {
            View v = new View(getContext());
            v.setBackgroundColor(ContextCompat.getColor(getContext(), R.color.purple_500));
            ll.addView(v, new LinearLayout.LayoutParams((int)(0.5*density), ViewGroup.LayoutParams.MATCH_PARENT, 0));
        }
        {
            View v = new View(getContext());
            v.setBackgroundColor(Color.TRANSPARENT);
            ll.addView(v, new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.MATCH_PARENT, 3));
        }
        return ll;
    }
    private void reSort(ArrayList<JSONObject> lst, final String ky) {
        Comparator<JSONObject> cjo = new  Comparator<JSONObject>()
        {
            // Used for sorting in ascending order of
            // roll number
            public int compare(JSONObject a, JSONObject b)
            {
                if (ky.equals("count"))
                    return a.optInt(ky)-(b.optInt(ky));
                else if (ky.equals("name"))
                    return a.optString(ky).compareTo(b.optString(ky));
                else {
                    LocalDate ad = LocalDate.parse(a.optString(ky));
                    LocalDate bd = LocalDate.parse(b.optString(ky));
                    return ad.compareTo(bd);
                }

            }
        };
        //noinspection Java8ListSort
        Collections.sort(lst, cjo);
    }

    private void gotData2(ArrayList<JSONObject> aList)
    {
        mainLayout.removeAllViews();
        ListView theLv = new ListView(getContext());
        //reSort(aList, "first");
        mainLayout.addView(theLv, new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
        theLv.setChoiceMode(ListView.CHOICE_MODE_SINGLE);
        theLv.setBackgroundColor(Color.rgb(240, 240, 240));
        theLv.setDivider(new ColorDrawable(ContextCompat.getColor(getContext(), R.color.purple_700)));
        theLv.setDividerHeight((int)(2*getResources().getDisplayMetrics().density));
        theLv.setStackFromBottom(false);
        theLv.setTranscriptMode(ListView.TRANSCRIPT_MODE_ALWAYS_SCROLL);
        ArrayAdapter<JSONObject> aa = new ArrayAdapter<JSONObject>(getContext(), 0, aList)
        {

            @NonNull
            @SuppressLint("InflateParams")
            @Override
            public View getView(int position, View convertView, @NonNull ViewGroup parent)
            {
                View view = convertView;
                if (view == null)
                {
                    view = new LinearLayout(getContext());
                }
                final JSONObject msg = this.getItem(position);
                float density = getResources().getDisplayMetrics().density;
                LinearLayout ll = (LinearLayout) view;
                ll.removeAllViews();
                ll.setOrientation(LinearLayout.HORIZONTAL);
                ll.setLayoutParams(new AbsListView.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, (int)(42*density)));
                {
                    TextView tv = new TextView(getContext());
                    tv.setPadding((int)(3*density),0,0,0);
                    tv.setText(msg.optString("name", "name"));
                    tv.setGravity(Gravity.START | Gravity.CENTER_VERTICAL);
                    ll.addView(tv, new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.MATCH_PARENT, 3));
                }
                {
                    View v = new View(getContext());
                    v.setBackgroundColor(ContextCompat.getColor(getContext(), R.color.purple_500));
                    ll.addView(v, new LinearLayout.LayoutParams((int)(0.5*density), ViewGroup.LayoutParams.MATCH_PARENT, 0));
                }
                {
                    TextView tv = new TextView(getContext());
                    tv.setText(msg.optString("count", "??"));
                    tv.setGravity(Gravity.CENTER_HORIZONTAL | Gravity.CENTER_VERTICAL);
                    ll.addView(tv, new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.MATCH_PARENT, 1));
                }
                {
                    View v = new View(getContext());
                    v.setBackgroundColor(ContextCompat.getColor(getContext(), R.color.purple_500));
                    ll.addView(v, new LinearLayout.LayoutParams((int)(0.5*density), ViewGroup.LayoutParams.MATCH_PARENT, 0));
                }
                {
                    TextView tv = new TextView(getContext());
                    tv.setPadding((int)(3*density),0,0,0);
                    tv.setText(msg.optString("first", "first"));
                    tv.setGravity(Gravity.START | Gravity.CENTER_VERTICAL);
                    ll.addView(tv, new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.MATCH_PARENT, 3));
                }
                {
                    View v = new View(getContext());
                    v.setBackgroundColor(ContextCompat.getColor(getContext(), R.color.purple_500));
                    ll.addView(v, new LinearLayout.LayoutParams((int)(0.5*density), ViewGroup.LayoutParams.MATCH_PARENT, 0));
                }
                {
                    TextView tv = new TextView(getContext());
                    tv.setPadding((int)(3*density),0,0,0);
                    tv.setText(msg.optString("recent", "recent"));
                    tv.setGravity(Gravity.START | Gravity.CENTER_VERTICAL);
                    ll.addView(tv, new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.MATCH_PARENT, 3));
                }
                {
                    View v = new View(getContext());
                    v.setBackgroundColor(ContextCompat.getColor(getContext(), R.color.purple_500));
                    ll.addView(v, new LinearLayout.LayoutParams((int)(0.5*density), ViewGroup.LayoutParams.MATCH_PARENT, 0));
                }
                {
                    TextView m = new TextView(getContext());
                    m.setGravity(Gravity.CENTER);
                    SpannableString mySpannableString = new SpannableString("vehicle details");
                    mySpannableString.setSpan(new UnderlineSpan(), 0, mySpannableString.length(), 0);
                    m.setText(mySpannableString);
                    m.setTextSize(10);
                    m.setTextColor(Color.rgb(0, 122, 255));
                    ll.addView(m, new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.WRAP_CONTENT, 3));
                    m.setOnClickListener(new View.OnClickListener()
                    {
                        @Override
                        public void onClick(View view)
                        {
                            Log.i("THISS", "launcher datails");
                            Toast.makeText(getContext(), "Launcher details", Toast.LENGTH_SHORT).show();
                            FragmentManager fragmentManager = ((AppCompatActivity)getContext()).getSupportFragmentManager();
                            FragmentTransaction transaction = fragmentManager.beginTransaction();
                            transaction.replace(MainActivity.MAIN_ACTIVITY_ID, new FragmentLauncherDetails(msg), null);
                            transaction.addToBackStack(null);
                            transaction.commit();
                        }
                    });

                }
                return view;
            }

        };
        theLv.setAdapter(aa);
        theLv.addHeaderView(headerRow(aList, aa));
        theLv.setOnItemClickListener(new AdapterView.OnItemClickListener() {

            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                JSONObject o = (JSONObject)theLv.getItemAtPosition(position);
                Toast.makeText(getContext(), o.toString(),Toast.LENGTH_SHORT).show();
                FragmentManager fragmentManager = ((AppCompatActivity)getContext()).getSupportFragmentManager();
                FragmentTransaction transaction = fragmentManager.beginTransaction();
                transaction.replace(MainActivity.MAIN_ACTIVITY_ID, new FragmentLaunches(o), null);
                transaction.addToBackStack(null);
                transaction.commit();
            }
        });
    }


    private class GetLaunchersRunner extends DownloadRunner
    {
        WeakReference<FragmentLauncher> wf;
        GetLaunchersRunner(FragmentLauncher caller)
        {
            Log.i("THISS", "new user matches task");
            wf = new WeakReference<>(caller);
        }

        @Override
        public void run()
        {
            Log.i("THISS", "GetLaunchersRunnerr running");
            final String[][] ee = {
                    {"ActionPageSize", "1"},
                    {"ActionPageNo", "1"},
            };
            // temp holder of return value
            String res;
            switch (set2get) {
                case MainActivity.MAT_BY_SOUNDER:
                    res = webInvokeJSON("http://comet.cs.brynmawr.edu/~gtowell/380/rocket/sounders.php", ee);
                    break;
                default:
                case MainActivity.MAT_BY_LAUNCHER:
                    res = webInvokeJSON("http://comet.cs.brynmawr.edu/~gtowell/380/rocket/launchers.php", ee);
                    break;
            }
            if (res ==null)
            {
                // communication failure!!! so should return false
                new Handler(Looper.getMainLooper()).post(new Runnable()
                {
                    @Override
                    public void run()
                    {
                        FragmentLauncher fl = wf.get();
                        if (fl!=null)
                            fl.stopAndFail("Failed to get information from server");
                    }
                });
                return;
            }
            try
            {
                Log.i("THISS", "MatchesAAA " + res);
                JSONArray jo = new JSONArray(res);
                Log.i("THISS", "MatchesAAA " + jo);
                new Handler(Looper.getMainLooper()).post(new Runnable()
                    {
                        @Override
                        public void run()
                        {
                            FragmentLauncher fl = wf.get();
                            if (fl!=null) {
                                ArrayList<JSONObject> al = new ArrayList<>();
                                for (int i = 0; i < jo.length(); i++) {
                                    try {
                                        al.add(jo.getJSONObject(i));
                                    } catch (Exception e) {
                                        Log.e("THISS", "EE", e);
                                    }
                                }
                                fl.gotData(al);
                            }
                        }
                    });
                    return;
            }
            catch (Exception eee)
            {
                Log.e("THISS", "Problme", eee);
            }
            /*
            new Handler(Looper.getMainLooper()).post(new Runnable()
            {
                @Override
                public void run()
                {
                    FragmentLauncher fl = wf.get();
                    if (fl!=null)
                        fl.stopAndFail("Something weird happened");
                }
            });
             */
            // lambda expression replaces the stuff in comment above.  Sure the lambda expression is more compact,
            // but the above is much more readable.
            new Handler(Looper.getMainLooper()).post(() -> {
                FragmentLauncher fl = wf.get();
                if (fl!=null)
                    fl.stopAndFail("Something weird happened");
            });
        }
    }


    public static class ItemArrayAdapter extends RecyclerView.Adapter<ViewHolder> {

        //All methods in this adapter are required for a bare minimum recyclerview adapter
        private final ArrayList<JSONObject> itemList;

        // Constructor of the class
        public ItemArrayAdapter(ArrayList<JSONObject> itemList) {
            this.itemList = itemList;
        }

        // get the size of the list
        @Override
        public int getItemCount() {
            return itemList == null ? 0 : itemList.size();
        }


        // specify the row layout file and click for each row
        @NonNull
        @Override
        public ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
            //View view = LayoutInflater.from(parent.getContext()).inflate(listItemLayout, parent, false);
            //ViewHolder myViewHolder = new ViewHolder(view);

            View v2 = new LinearLayout(parent.getContext());
            v2.setLayoutParams(new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT));

            return new ViewHolder(v2);
        }


        // load data in each row element
        @Override
        public void onBindViewHolder(final ViewHolder holder, final int listPosition) {
            TextView item = holder.item;
            item.setText(itemList.get(listPosition).optString("name", "name"));
            TextView item2 = holder.item2;
            item2.setText(itemList.get(listPosition).optString("count", "count"));
        }
    }

    static class ViewHolder extends RecyclerView.ViewHolder implements View.OnClickListener {
        public TextView item;
        public TextView item2;
        public ViewHolder(View itemView) {
            super(itemView);
            itemView.setOnClickListener(this);
            Log.i("THISS", itemView + " ");
            //item = (TextView) itemView.findViewById(R.id.row_item);
            LinearLayout ll = (LinearLayout)itemView;
            item = new TextView(itemView.getContext());
            ll.addView(item);
            item.setLayoutParams(new LinearLayout.LayoutParams(0, (int)(30*itemView.getContext().getResources().getDisplayMetrics().density), 1));
            item2 = new TextView(itemView.getContext());
            ll.addView(item2);
            item2.setLayoutParams(new LinearLayout.LayoutParams(0, (int)(30*itemView.getContext().getResources().getDisplayMetrics().density), 2));
        }

        @Override
        public void onClick(View view) {
            Log.d("THISS", "onClick " + getLayoutPosition() + " " + item.getText());
            FragmentManager fragmentManager = ((AppCompatActivity)view.getContext()).getSupportFragmentManager();
            FragmentTransaction transaction = fragmentManager.beginTransaction();
            transaction.replace(MainActivity.MAIN_ACTIVITY_ID, new FragmentLaunches(item.getText().toString()), null);
            transaction.addToBackStack(null);
            transaction.commit();
        }
    }

    RecyclerView recyclerView;
    private void gotData3(ArrayList<JSONObject> aList)
    {
        mainLayout.removeAllViews();
        ItemArrayAdapter itemArrayAdapter = new ItemArrayAdapter(aList);
        recyclerView = new RecyclerView(getContext());
        mainLayout.addView(recyclerView, new RelativeLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
        recyclerView.setLayoutManager(new LinearLayoutManager(getContext()));
        recyclerView.setItemAnimator(new DefaultItemAnimator());
        recyclerView.setAdapter(itemArrayAdapter);
        DividerItemDecoration divider = new DividerItemDecoration(recyclerView.getContext(), DividerItemDecoration.VERTICAL);
        divider.setDrawable(new ColorDrawable(ContextCompat.getColor(getContext(), R.color.purple_200)));
        recyclerView.addItemDecoration(divider);

    }

}
