package edu.brynmawr.RocketA;

import android.animation.Animator;
import android.animation.AnimatorListenerAdapter;
import android.annotation.SuppressLint;
import android.graphics.Color;
import android.graphics.Typeface;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.util.Log;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.core.content.ContextCompat;
import androidx.fragment.app.Fragment;

import org.json.JSONArray;
import org.json.JSONObject;

import java.lang.ref.WeakReference;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Random;
import java.util.concurrent.Executor;
import java.util.concurrent.RejectedExecutionException;

public class FragmentLauncherDetails extends Fragment {

    private RelativeLayout mainLayout;
    private JSONObject launcher;

    public FragmentLauncherDetails(JSONObject jo) {
        this.launcher=jo;
    }

    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState ) {
        // set up the initial layout
        RelativeLayout ll = new RelativeLayout(getContext());
        ll.setId(View.generateViewId());
        ll.setLayoutParams(new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
        mainLayout = ll;
        return ll;
    }

    /**
     * Generate a random color
     * @return the random color
     */
    private int randomColor() {
        Random r = new Random();
        return Color.rgb(r.nextInt(255), r.nextInt(255), r.nextInt(255));
    }

    public void onViewCreated(@NonNull View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        /*
        TypedValue tv = new TypedValue();
        if (getContext().getTheme().resolveAttribute(android.R.attr.actionBarSize, tv, true)) {
            int actionBarHeight = TypedValue.complexToDimensionPixelSize(tv.data, getResources().getDisplayMetrics());
            view.setPadding(0, actionBarHeight, 0, 0);
        }
*/
        layoutFetching();
    }

    private void layoutFetching() {
        mainLayout.setBackgroundColor(randomColor());
        TextView tv = new TextView(getContext());
        tv.setText("Fetching Launcher Details");
        tv.setGravity(Gravity.CENTER);
        ViewGroup.LayoutParams lp = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT);
        mainLayout.addView(tv, lp);

        tv.setRotation(0);
        tv.animate().rotation(2880).setDuration(30000).setListener(new AnimatorListenerAdapter() {
            @Override
            public void onAnimationEnd(Animator animation) {
                super.onAnimationEnd(animation);
            }
        });
        Executor exec = new Executor() {
            @Override
            public void execute(Runnable command) {
                new Thread(command).start();
            }
        };
        try {
            exec.execute(new FragmentLauncherDetails.GetLauncherDetailsRunner(this, launcher));
        }
        catch (RejectedExecutionException | NullPointerException exception) {
            Log.e("THISS", "Thread problem", exception);
        }
    }

    private void stopAndFail(String failMessage) {
        mainLayout.removeAllViews();
        TextView tv = new TextView(getContext());
        tv.setText(failMessage);
        tv.setGravity(Gravity.CENTER);
        ViewGroup.LayoutParams lp = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT);
        mainLayout.addView(tv, lp);

    }

    private void gotData(JSONObject jOb)
    {
        mainLayout.removeAllViews();
        /*
        {
            TextView tv = new TextView(getContext());
            tv.setText(jOb.toString());
            tv.setGravity(Gravity.CENTER);
            mainLayout.addView(tv, new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
        }
         */
        ArrayList<String> ss = new ArrayList<>();
        Iterator<String> k = jOb.keys();
        while (k.hasNext())
            ss.add(k.next());

        ListView theLv = new ListView(getContext());
        mainLayout.addView(theLv, new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
        theLv.setChoiceMode(ListView.CHOICE_MODE_SINGLE);
        theLv.setBackgroundColor(Color.rgb(240, 240, 240));
        theLv.setDivider(new ColorDrawable(ContextCompat.getColor(getContext(), R.color.purple_200)));
        theLv.setDividerHeight((int)(1*getResources().getDisplayMetrics().density));
        theLv.setStackFromBottom(false);
        theLv.setTranscriptMode(ListView.TRANSCRIPT_MODE_ALWAYS_SCROLL);
        ArrayAdapter<String> aa = new ArrayAdapter<String>(getContext(), 0, ss)
        {

            @NonNull
            @SuppressLint("InflateParams")
            @Override
            public View getView(int position, View convertView, @NonNull ViewGroup parent)
            {
                View view = convertView;
                if (view == null)
                {
                    view = new LinearLayout(getContext());
                }
                String jKey = this.getItem(position);
                LinearLayout ll = (LinearLayout) view;
                ll.removeAllViews();
                ll.setOrientation(LinearLayout.HORIZONTAL);
                ll.setLayoutParams(new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT));
                {
                    TextView tv = new TextView(getContext());
                    tv.setText(jKey+":");
                    tv.setTypeface(null, Typeface.BOLD);
                    tv.setTextSize(16);
                    tv.setTextColor(ContextCompat.getColor(getContext(), R.color.purple_700));
                    tv.setGravity(Gravity.LEFT | Gravity.CENTER_VERTICAL);
                    float density = getResources().getDisplayMetrics().density;
                    tv.setPadding((int)(3*density), (int)(8*density), 0, (int)(8*density));
                    ll.addView(tv, new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.WRAP_CONTENT, 1));
                }
                {
                    TextView tv = new TextView(getContext());
                    tv.setText(jOb.optString(jKey, "N.A."));
                    tv.setTextSize(16);
                    tv.setGravity(Gravity.LEFT | Gravity.CENTER_VERTICAL);
                    float density = getResources().getDisplayMetrics().density;
                    tv.setPadding((int)(3*density), (int)(8*density), 0, (int)(8*density));
                    ll.addView(tv, new LinearLayout.LayoutParams(0, ViewGroup.LayoutParams.WRAP_CONTENT, 2));
                }
                return view;
            }

        };
        theLv.setAdapter(aa);
    }


    private static class GetLauncherDetailsRunner extends DownloadRunner
    {
        WeakReference<FragmentLauncherDetails> wf;
        JSONObject vSpec;
        GetLauncherDetailsRunner(FragmentLauncherDetails caller, JSONObject vehSpec)
        {
            Log.i("THISS", "VSPEC " + vehSpec);
            this.vSpec=vehSpec;
            wf = new WeakReference<>(caller);
        }

        @Override
        public void run()
        {
            Log.i("THISS", "GetLaunchesRunnerr running");
            final String[][] ee = {
                    {"veh", vSpec.optString("name")},
            };
            // temp holder of return value
            String res = webInvokeJSON("http://comet.cs.brynmawr.edu/~gtowell/380/rocket/launcherDetailsJ.php", ee);
            if (res ==null)
            {
                // communication failure!!! so should return false
                new Handler(Looper.getMainLooper()).post(new Runnable()
                {
                    @Override
                    public void run()
                    {
                        FragmentLauncherDetails fl = wf.get();
                        if (fl!=null)
                            fl.stopAndFail("Failed to get information from server");
                    }
                });
                return;
            }
            try
            {
                Log.i("THISS", "MatchesAAA " + res);
                JSONArray jo = new JSONArray(res);
                //Log.i("THISS", "MatchesAAA " + jo);
                new Handler(Looper.getMainLooper()).post(new Runnable()
                {
                    @Override
                    public void run()
                    {
                        FragmentLauncherDetails fl = wf.get();
                        if (fl!=null) {
                            fl.gotData(jo.optJSONObject(0));
                        }
                    }
                });
                return;
            }
            catch (Exception eee)
            {
                Log.e("THISS", "Problme", eee);
            }
            new Handler(Looper.getMainLooper()).post(new Runnable()
            {
                @Override
                public void run()
                {
                    FragmentLauncherDetails fl = wf.get();
                    if (fl!=null)
                        fl.stopAndFail("Something weird happened");
                }
            });
        }
    }


}
