package edu.brynmawr.RocketA;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import androidx.core.content.ContextCompat;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import android.os.Bundle;
import android.util.Log;
import android.util.TypedValue;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.Toast;

public class MainActivity extends AppCompatActivity {

    public static int MAIN_ACTIVITY_ID = 17447;
    public static final int MAT_BY_LAUNCHER = 17448;
    public static final int MAT_BY_SOUNDER = 17449;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        RelativeLayout vv = this.findViewById(R.id.mainlinearlayout);
        MAIN_ACTIVITY_ID = R.id.mainlinearlayout;
        /*
        RelativeLayout vv = new RelativeLayout(this);
        float density = getResources().getDisplayMetrics().density;
        vv.setId(MAIN_ACTIVITY_ID);
        TypedValue tv = new TypedValue();
        int actionBarHeight=40;
        if (this.getTheme().resolveAttribute(android.R.attr.actionBarSize, tv, true)) {
            actionBarHeight = TypedValue.complexToDimensionPixelSize(tv.data, getResources().getDisplayMetrics());
        }
        Log.i("THISS", "ABH  " + actionBarHeight);
        vv.setLayoutParams(new ViewGroup.LayoutParams(getResources().getDisplayMetrics().widthPixels, (int)(getResources().getDisplayMetrics().heightPixels-actionBarHeight-24*density)));
        setContentView(vv);
*/

        /*
        Toolbar toolbar = new Toolbar(this);
        toolbar.setId(View.generateViewId());
        ViewGroup.LayoutParams layoutParams = new ViewGroup.LayoutParams(
                LinearLayout.LayoutParams.MATCH_PARENT, actionBarHeight);
        toolbar.setLayoutParams(layoutParams);
        toolbar.setBackgroundColor(ContextCompat.getColor(this, R.color.purple_200));
        toolbar.setTitle(getResources().getString(R.string.app_name)+"!!!");
        toolbar.setVisibility(View.VISIBLE);

        vv.addView(toolbar, 0);
        setSupportActionBar(toolbar);
        */
        FragmentManager fragmentManager = this.getSupportFragmentManager();
        FragmentTransaction transaction = fragmentManager.beginTransaction();
        transaction.replace(MAIN_ACTIVITY_ID, new FragmentWelcome(), null);
        transaction.addToBackStack(null);
        transaction.commit();
        int tt = fragmentManager.getBackStackEntryCount();
        for(int i = 0; i < tt; ++i) {
            fragmentManager.popBackStack();
        }
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu){

        {
            MenuItem edit_item = menu.add(0, MAT_BY_LAUNCHER, 1, "Orbital Launchers");
            edit_item.setShowAsActionFlags(MenuItem.SHOW_AS_ACTION_NEVER);
        }
        {
            MenuItem edit_item = menu.add(0, MAT_BY_SOUNDER, 1, "Sounding Rockets");
            edit_item.setShowAsActionFlags(MenuItem.SHOW_AS_ACTION_NEVER);
        }
        /*
        MenuItem delete_item = menu.add(0, 17235, 2, "Geoff");
        delete_item.setShowAsActionFlags(MenuItem.SHOW_AS_ACTION_NEVER);
        MenuItem geoff2 = menu.add(1, 17236, 3, "Geoff2");
        geoff2.setShowAsActionFlags(MenuItem.SHOW_AS_ACTION_ALWAYS);
*/
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();
        Log.i("THISS", "Clicked on menu item " + id);
        if (id == MAT_BY_LAUNCHER || id==MAT_BY_SOUNDER) {
            //Toast.makeText(this, "BY LAUNCHER", Toast.LENGTH_LONG).show();
            FragmentManager fragmentManager = this.getSupportFragmentManager();
            FragmentTransaction transaction = fragmentManager.beginTransaction();
            transaction.replace(MAIN_ACTIVITY_ID, new FragmentLauncher(id), null);
            transaction.addToBackStack(null);
            transaction.commit();
            return true;
        }
        /*
        if (id == MAT_GEOFF) {
            Toast.makeText(this, "Geoff Geoff Geoff Geoff", Toast.LENGTH_LONG).show();
            FragmentManager fragmentManager = this.getSupportFragmentManager();
            FragmentTransaction transaction = fragmentManager.beginTransaction();
            transaction.replace(MAIN_ACTIVITY_ID, new LinearFragment2(), null);
            transaction.addToBackStack(null);
            transaction.commit();
            return true;
        }
*/
        return super.onOptionsItemSelected(item);
    }

    public void onBackPressed() {
        FragmentManager fragmentManager = this.getSupportFragmentManager();
        int tt = fragmentManager.getBackStackEntryCount();
        Log.i("THISs", "Back stack " + tt);
        if (tt>1)
            super.onBackPressed();
    }

}